blob: 25771ecfb7f7aa090dcdc29da77551a23ff7eecd [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070035test_dir="test-$$"
36tmp_dir="/tmp/${test_dir}"
jeffhao5d1ac922011-09-29 17:41:15 -070037
38export JAVA="java"
Elliott Hughes4b0d1ee2011-11-30 14:11:39 -080039export JAVAC="javac -g -target 1.5"
jeffhao5d1ac922011-09-29 17:41:15 -070040export RUN="${progdir}/etc/push-and-run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070041export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070042export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070043
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070044# If dx was not set by the environment variable, assume it is in the path.
45if [ -z "$DX" ]; then
46 export DX="dx"
47fi
48
jeffhao5d1ac922011-09-29 17:41:15 -070049info="info.txt"
50build="build"
51run="run"
52expected="expected.txt"
53output="output.txt"
54build_output="build-output.txt"
55run_args="--quiet"
56
Brian Carlstrom2613de42012-06-15 17:37:16 -070057target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070058dev_mode="no"
59update_mode="no"
60debug_mode="no"
61usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070062build_only="no"
jeffhao5d1ac922011-09-29 17:41:15 -070063
64while true; do
65 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -070066 target_mode="no"
jeffhao5d1ac922011-09-29 17:41:15 -070067 RUN="${progdir}/etc/host-run-test-jar"
TDYa127b92bcab2012-04-08 00:09:51 -070068 DEX_LOCATION=$tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -070069 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080070 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -070071 target_mode="no"
jeffhao5d1ac922011-09-29 17:41:15 -070072 RUN="${progdir}/etc/reference-run-test-classes"
Elliott Hughesc717eef2012-06-15 16:01:26 -070073 NEED_DEX="false"
jeffhao5d1ac922011-09-29 17:41:15 -070074 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -080075 elif [ "x$1" = "x-O" ]; then
76 run_args="${run_args} -O"
Elliott Hughes7c046102011-10-19 18:16:03 -070077 shift
jeffhao5d1ac922011-09-29 17:41:15 -070078 elif [ "x$1" = "x--debug" ]; then
79 run_args="${run_args} --debug"
80 shift
81 elif [ "x$1" = "x--gdb" ]; then
82 run_args="${run_args} --gdb"
83 dev_mode="yes"
84 shift
85 elif [ "x$1" = "x--zygote" ]; then
86 run_args="${run_args} --zygote"
87 shift
88 elif [ "x$1" = "x--no-verify" ]; then
89 run_args="${run_args} --no-verify"
90 shift
91 elif [ "x$1" = "x--no-optimize" ]; then
92 run_args="${run_args} --no-optimize"
93 shift
94 elif [ "x$1" = "x--no-precise" ]; then
95 run_args="${run_args} --no-precise"
96 shift
Elliott Hughes7c046102011-10-19 18:16:03 -070097 elif [ "x$1" = "x--invoke-with" ]; then
98 shift
99 what="$1"
100 run_args="${run_args} --invoke-with \"${what}\""
jeffhao5d1ac922011-09-29 17:41:15 -0700101 shift
102 elif [ "x$1" = "x--dev" ]; then
103 run_args="${run_args} --dev"
104 dev_mode="yes"
105 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700106 elif [ "x$1" = "x--build-only" ]; then
107 build_only="yes"
108 shift
109 elif [ "x$1" = "x--output-path" ]; then
110 shift
111 tmp_dir=$1
112 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700113 elif [ "x$1" = "x--update" ]; then
114 update_mode="yes"
115 shift
116 elif [ "x$1" = "x--help" ]; then
117 usage="yes"
118 shift
119 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700120 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700121 usage="yes"
122 break
123 else
124 break
125 fi
126done
127
128if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
129 echo "--dev and --update are mutually exclusive" 1>&2
130 usage="yes"
131fi
132
133if [ "$usage" = "no" ]; then
134 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
135 test_dir=`basename "$oldwd"`
136 else
137 test_dir="$1"
138 fi
139
140 if [ '!' -d "$test_dir" ]; then
141 td2=`echo ${test_dir}-*`
142 if [ '!' -d "$td2" ]; then
143 echo "${test_dir}: no such test directory" 1>&2
144 usage="yes"
145 fi
146 test_dir="$td2"
147 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700148 # Shift to get rid of the test name argument. The rest of the arguments
149 # will get passed to the test run.
150 shift
151fi
152
153if [ "$usage" = "yes" ]; then
154 prog=`basename $prog`
155 (
156 echo "usage:"
157 echo " $prog --help Print this message."
158 echo " $prog [options] [test-name] Run test normally."
159 echo " $prog --dev [options] [test-name] Development mode" \
160 "(dumps to stdout)."
161 echo " $prog --update [options] [test-name] Update mode" \
162 "(replaces expected.txt)."
163 echo ' Omitting the test name or specifying "-" will use the' \
164 "current directory."
165 echo " Runtime Options:"
Elliott Hughes58bcc402012-02-14 14:10:10 -0800166 echo " -O Run oatexec rather than oatexecd (off by default)."
jeffhao5d1ac922011-09-29 17:41:15 -0700167 echo " --debug Wait for a debugger to attach."
168 #echo " --gdb Run under gdb; incompatible with some tests."
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700169 echo " --build-only Build test files only (off by default)."
jeffhao5d1ac922011-09-29 17:41:15 -0700170 echo " --no-verify Turn off verification (on by default)."
171 echo " --no-optimize Turn off optimization (on by default)."
172 echo " --no-precise Turn off precise GC (on by default)."
173 echo " --zygote Spawn the process from the Zygote." \
174 "If used, then the"
175 echo " other runtime options are ignored."
176 echo " --host Use the host-mode virtual machine."
177 echo " --valgrind Use valgrind when running locally."
Elliott Hughes58bcc402012-02-14 14:10:10 -0800178 echo " --jvm Use a host-local RI virtual machine."
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700179 echo " --output-path [path] Location where to store the build" \
180 "files."
jeffhao5d1ac922011-09-29 17:41:15 -0700181 ) 1>&2
182 exit 1
183fi
184
185cd "$test_dir"
186test_dir=`pwd`
187
188td_info="${test_dir}/${info}"
189td_expected="${test_dir}/${expected}"
190
jeffhao5d1ac922011-09-29 17:41:15 -0700191if [ '!' '(' -r "$td_info" -a -r "$td_expected" ')' ]; then
192 echo "${test_dir}: missing files" 1>&2
193 exit 1
194fi
195
196# copy the test to a temp dir and run it
197
Elliott Hughes510c8782011-10-06 10:57:34 -0700198echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700199
200rm -rf "$tmp_dir"
201cp -Rp "$test_dir" "$tmp_dir"
202cd "$tmp_dir"
203
204if [ '!' -r "$build" ]; then
205 cp "${progdir}/etc/default-build" build
206fi
207
Elliott Hughes510c8782011-10-06 10:57:34 -0700208echo "${test_dir}: running..." 1>&2
209
jeffhao5d1ac922011-09-29 17:41:15 -0700210if [ '!' -r "$run" ]; then
211 cp "${progdir}/etc/default-run" run
212fi
213
214chmod 755 "$build"
215chmod 755 "$run"
216
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700217export TEST_NAME=`basename ${test_dir}`
218
jeffhao5d1ac922011-09-29 17:41:15 -0700219good="no"
220if [ "$dev_mode" = "yes" ]; then
221 "./${build}" 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700222 build_exit="$?"
223 echo "build exit status: $build_exit" 1>&2
224 if [ "$build_exit" = '0' ]; then
225 "./${run}" $run_args "$@" 2>&1
226 echo "run exit status: $?" 1>&2
227 good="yes"
228 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700229elif [ "$update_mode" = "yes" ]; then
230 "./${build}" >"$build_output" 2>&1
231 build_exit="$?"
232 if [ "$build_exit" = '0' ]; then
233 "./${run}" $run_args "$@" >"$output" 2>&1
234 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
235 good="yes"
236 else
237 cat "$build_output" 1>&2
238 echo "build exit status: $build_exit" 1>&2
239 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700240elif [ "$build_only" = "yes" ]; then
241 good="yes"
242 "./${build}" >"$build_output" 2>&1
243 build_exit="$?"
244 if [ "$build_exit" '!=' '0' ]; then
245 cp "$build_output" "$output"
246 echo "build exit status: $build_exit" >>"$output"
247 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
248 if [ "$?" '!=' "0" ]; then
249 good="no"
250 echo "BUILD FAILED For ${TEST_NAME}"
251 fi
252 fi
253 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700254else
255 "./${build}" >"$build_output" 2>&1
256 build_exit="$?"
257 if [ "$build_exit" = '0' ]; then
258 "./${run}" $run_args "$@" >"$output" 2>&1
259 else
260 cp "$build_output" "$output"
261 echo "build exit status: $build_exit" >>"$output"
262 fi
263 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
264 if [ "$?" = "0" ]; then
265 # output == expected
266 good="yes"
267 echo "${test_dir}: succeeded!" 1>&2
268 fi
269fi
270
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700271# Clean up test files.
272if [ "$good" == "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700273 cd "$oldwd"
274 rm -rf "$tmp_dir"
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700275 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Brian Carlstrom105215d2012-06-14 12:50:44 -0700276 adb shell rm -r $DEX_LOCATION
277 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700278 exit 0
279fi
280
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700281
jeffhao5d1ac922011-09-29 17:41:15 -0700282(
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700283 if [ "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700284 echo "${test_dir}: FAILED!"
285 echo ' '
286 echo '#################### info'
287 cat "${td_info}" | sed 's/^/# /g'
288 echo '#################### diffs'
289 diff --strip-trailing-cr -u "$expected" "$output"
290 echo '####################'
291 echo ' '
292 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700293 echo "${TEST_NAME} files left in ${tmp_dir} on host"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700294 if [ "$target_mode" == "yes" ]; then
Brian Carlstrom105215d2012-06-14 12:50:44 -0700295 echo "and in ${DEX_LOCATION} on target"
296 fi
297
jeffhao5d1ac922011-09-29 17:41:15 -0700298) 1>&2
299
300exit 1